libgphoto2 (libgphoto2): libgphoto2/gphoto2-widget.c File Reference

- Main Page
- Data Structures
- Files
- Directories
- Related Pages

- File List
- Globals

# gphoto2-widget.c File Reference

`#include "config.h"`
`#include <gphoto2/gphoto2-widget.h>`
`#include <stdlib.h>`
`#include <string.h>`
`#include <gphoto2/gphoto2-result.h>`
`#include <gphoto2/gphoto2-port-log.h>`

## Data Structures
struct | _CameraWidget
## Defines
#define | CHECK_NULL(r) {if (!(r)) return (GP_ERROR_BAD_PARAMETERS);}
## Functions
int | gp_widget_new (CameraWidgetType type, const char *label, CameraWidget **widget)
int | gp_widget_free (CameraWidget *widget)
int | gp_widget_ref (CameraWidget *widget)
int | gp_widget_unref (CameraWidget *widget)
int | gp_widget_get_info (CameraWidget *widget, const char **info)
int | gp_widget_set_info (CameraWidget *widget, const char *info)
int | gp_widget_get_name (CameraWidget *widget, const char **name)
int | gp_widget_set_name (CameraWidget *widget, const char *name)
int | gp_widget_get_id (CameraWidget *widget, int *id)
int | gp_widget_set_changed (CameraWidget *widget, int changed)
int | gp_widget_get_type (CameraWidget *widget, CameraWidgetType *type)
int | gp_widget_get_label (CameraWidget *widget, const char **label)
int | gp_widget_set_value (CameraWidget *widget, const void *value)
int | gp_widget_get_value (CameraWidget *widget, void *value)
int | gp_widget_append (CameraWidget *widget, CameraWidget *child)
int | gp_widget_prepend (CameraWidget *widget, CameraWidget *child)
int | gp_widget_count_children (CameraWidget *widget)
int | gp_widget_get_child (CameraWidget *widget, int child_number, CameraWidget **child)
int | gp_widget_get_child_by_label (CameraWidget *widget, const char *label, CameraWidget **child)
int | gp_widget_get_child_by_id (CameraWidget *widget, int id, CameraWidget **child)
int | gp_widget_get_child_by_name (CameraWidget *widget, const char *name, CameraWidget **child)
int | gp_widget_get_parent (CameraWidget *widget, CameraWidget **parent)
int | gp_widget_get_root (CameraWidget *widget, CameraWidget **root)
int | gp_widget_set_range (CameraWidget *range, float min, float max, float increment)
int | gp_widget_get_range (CameraWidget *range, float *min, float *max, float *increment)
int | gp_widget_add_choice (CameraWidget *widget, const char *choice)
int | gp_widget_count_choices (CameraWidget *widget)
int | gp_widget_get_choice (CameraWidget *widget, int choice_number, const char **choice)
int | gp_widget_changed (CameraWidget *widget)

## Detailed Description

Author:
  Copyright 2000 Scott Fritzinger

Note:
  This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License along with this library; if not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

## Function Documentation

int gp_widget_add_choice | ( | CameraWidget * | widget,
|  | const char * | choice |
| ) |  |  |

Adds a choice to the CameraWidget

Parameters:

  | widget | a CameraWidget of type GP_WIDGET_RADIO or GP_WIDGET_MENU
  | choice |

Returns:
  a gphoto2 error code.

int gp_widget_append | ( | CameraWidget * | widget,
|  | CameraWidget * | child |
| ) |  |  |

Appends a CameraWidget to a CameraWidget

Parameters:

  | widget | a CameraWidget
  | child | the CameraWidget you would like to append to above

Returns:
  a gphoto2 error code.

int gp_widget_changed | ( | CameraWidget * | widget | ) |

Tells if the widget has been changed

Parameters:

  | widget | a CameraWidget

Returns:
  a gphoto2 error code or changed flag.

Returns 1 if the state of the CameraWidget has been changed or 0 if not. In addition, it resets the changed flag to 0.

int gp_widget_count_children | ( | CameraWidget * | widget | ) |

Counts the children of the CameraWidget

Parameters:

  | widget | a CameraWidget

Returns:
  a gphoto2 error code or number of children

int gp_widget_count_choices | ( | CameraWidget * | widget | ) |

Counts the choices of the CameraWidget

Parameters:

  | widget | a CameraWidget of type GP_WIDGET_RADIO or GP_WIDGET_MENU

Returns:
  a gphoto2 error code or number of choices.

int gp_widget_free | ( | CameraWidget * | widget | ) |

Frees a CameraWidget

Parameters:

  | widget | the CameraWidget to be freed

Returns:
  a gphoto2 error code.

int gp_widget_get_child | ( | CameraWidget * | widget,
|  | int | child_number,
|  | CameraWidget ** | child |
| ) |  |  |

Retrieves the child number `child_number` of the parent

Parameters:

  | widget | a CameraWidget
  | child_number | the number of the child
  | child |

Returns:
  a gphoto2 error code.

int gp_widget_get_child_by_id | ( | CameraWidget * | widget,
|  | int | id,
|  | CameraWidget ** | child |
| ) |  |  |

Retrieves the child with id `id` of the widget

Parameters:

  | widget | a CameraWidget
  | id | the id of the child
  | child |

Returns:
  a gphoto2 error code.

int gp_widget_get_child_by_label | ( | CameraWidget * | widget,
|  | const char * | label,
|  | CameraWidget ** | child |
| ) |  |  |

Retrieves the child with label `label` of the CameraWidget

Parameters:

  | widget | a CameraWidget
  | label | the label of the child
  | child |

Returns:
  a gphoto2 error code.

int gp_widget_get_child_by_name | ( | CameraWidget * | widget,
|  | const char * | name,
|  | CameraWidget ** | child |
| ) |  |  |

Retrieves the child with name `name` of the widget

Parameters:

  | widget | a CameraWidget
  | name | the name of the child

Returns:
  a gphoto2 error code.

int gp_widget_get_choice | ( | CameraWidget * | widget,
|  | int | choice_number,
|  | const char ** | choice |
| ) |  |  |

Retrieves the choice number `choice_number`

Parameters:

  | widget | a CameraWidget of type GP_WIDGET_RADIO or GP_WIDGET_MENU
  | choice_number |
  | choice |

Returns:
  a gphoto2 error code

int gp_widget_get_id | ( | CameraWidget * | widget,
|  | int * | id |
| ) |  |  |

Retrieves the unique id of the CameraWidget

Parameters:

  | widget | a CameraWidget
  | id |

Returns:
  a gphoto2 error code.

int gp_widget_get_info | ( | CameraWidget * | widget,
|  | const char ** | info |
| ) |  |  |

Retrieves the information about the widget

Parameters:

  | widget | a CameraWidget
  | info |

Returns:
  a gphoto2 error code.

int gp_widget_get_label | ( | CameraWidget * | widget,
|  | const char ** | label |
| ) |  |  |

Retrieves the label of the CameraWidget

Parameters:

  | widget | a CameraWidget
  | label |

Returns:
  a gphoto2 error code.

int gp_widget_get_name | ( | CameraWidget * | widget,
|  | const char ** | name |
| ) |  |  |

Gets the name of the widget

Parameters:

  | widget | a CameraWidget
  | name | Name of above widget

Returns:
  a gphoto2 error code.

int gp_widget_get_range | ( | CameraWidget * | range,
|  | float * | min,
|  | float * | max,
|  | float * | increment |
| ) |  |  |

Retrieves some range parameters of the CameraWidget

Parameters:

  | range | a CameraWidget of type GP_WIDGET_RANGE
  | min |
  | max |
  | increment |

Returns:
  a gphoto2 error code.

int gp_widget_get_root | ( | CameraWidget * | widget,
|  | CameraWidget ** | root |
| ) |  |  |

Retrieves the root of the CameraWidget

Parameters:

  | widget | a CameraWidget
  | root |

Returns:
  a gphoto2 error code.

int gp_widget_get_type | ( | CameraWidget * | widget,
|  | CameraWidgetType * | type |
| ) |  |  |

Retrieves the type of the CameraWidget

Parameters:

  | widget | a CameraWidget
  | type |

Returns:
  a gphoto2 error code.

int gp_widget_get_value | ( | CameraWidget * | widget,
|  | void * | value |
| ) |  |  |

Retrieves the value of the CameraWidget

Parameters:

  | widget | a CameraWidget
  | value |

Returns:
  a gphoto2 error code.

int gp_widget_new | ( | CameraWidgetType | type,
|  | const char * | label,
|  | CameraWidget ** | widget |
| ) |  |  |

The function creates a new CameraWidget of specified type and with given label.

Parameters:

  | type | the type
  | label | the label
  | widget |

Returns:
  a gphoto2 error code.

int gp_widget_prepend | ( | CameraWidget * | widget,
|  | CameraWidget * | child |
| ) |  |  |

Prepends a CameraWidget to a CameraWidget

Parameters:

  | widget | a CameraWidget
  | child | the CameraWidget you would like to prepend to above

Returns:
  a gphoto2 error code.

int gp_widget_ref | ( | CameraWidget * | widget | ) |

Increments the reference count for the CameraWidget

Parameters:

  | widget | a CameraWidget you want to ref-count

Returns:
  a gphoto2 error code.

int gp_widget_set_info | ( | CameraWidget * | widget,
|  | const char * | info |
| ) |  |  |

Sets the information about the widget

Parameters:

  | widget | a CameraWidget
  | info | Information about above widget

Returns:
  a gphoto2 error code.

int gp_widget_set_name | ( | CameraWidget * | widget,
|  | const char * | name |
| ) |  |  |

Sets the name of the widget

Parameters:

  | widget | a CameraWidget
  | name | Name of above widget

Returns:
  a gphoto2 error code.

int gp_widget_set_range | ( | CameraWidget * | range,
|  | float | min,
|  | float | max,
|  | float | increment |
| ) |  |  |

Sets some range parameters of the CameraWidget

Parameters:

  | range | a CameraWidget of type GP_WIDGET_RANGE
  | min |
  | max |
  | increment |

Returns:
  a gphoto2 error code.

int gp_widget_set_value | ( | CameraWidget * | widget,
|  | const void * | value |
| ) |  |  |

Sets the value of the widget

Parameters:

  | widget | a CameraWidget
  | value |

Returns:
  a gphoto2 error code.

Please pass (char*) for GP_WIDGET_MENU, GP_WIDGET_TEXT, (float) for GP_WIDGET_RANGE, (int) for GP_WIDGET_DATE, GP_WIDGET_TOGGLE, GP_WIDGET_RADIO, and (CameraWidgetCallback) for GP_WIDGET_BUTTON.

int gp_widget_unref | ( | CameraWidget * | widget | ) |

Decrements the reference count for the CameraWidget

Parameters:

  | widget | a CameraWidget you want to unref

Returns:
  a gphoto2 error code.